// REQUIRES: aarch64-registered-target
// RUN: %clang_cc1 -triple aarch64-none-linux-gnu -target-feature +sve -target-feature +bf16 -fallow-half-arguments-and-returns -S -O1 -Werror -Wall -emit-llvm -o - %s | FileCheck %s
// RUN: %clang_cc1 -DSVE_OVERLOADED_FORMS -triple aarch64-none-linux-gnu -target-feature +sve -target-feature +bf16 -fallow-half-arguments-and-returns -S -O1 -Werror -Wall -emit-llvm -o - %s | FileCheck %s
// RUN: %clang_cc1 -triple aarch64-none-linux-gnu -target-feature +sve -target-feature +bf16 -fallow-half-arguments-and-returns -S -O1 -Werror -Wall -o - %s >/dev/null
#include <arm_sve.h>

#ifdef SVE_OVERLOADED_FORMS
// A simple used,unused... macro, long enough to represent any SVE builtin.
#define SVE_ACLE_FUNC(A1,A2_UNUSED,A3,A4_UNUSED) A1##A3
#else
#define SVE_ACLE_FUNC(A1,A2,A3,A4) A1##A2##A3##A4
#endif

uint64_t test_svlen_bf16(svbfloat16_t op)
{
  // CHECK-LABEL: test_svlen_bf16
  // CHECK: %[[VSCALE:.*]] = call i64 @llvm.vscale.i64()
  // CHECK: %[[SHL:.*]] = shl i64 %[[VSCALE]], 3
  // CHECK: ret i64 %[[SHL]]
  // expected-warning@+1 {{implicit declaration of function 'svlen_bf16'}}
  return SVE_ACLE_FUNC(svlen,_bf16,,)(op);
}
